member(X,[X|_]).
member(X,[_|L]) :- member(X,L).

append([],X,X).
append([X|Y],L,[X|Y1]) :- append(Y,L,Y1).

select(X,[X|L],L).
select(X,[Y|L],[Y|L1]) :- select(X,L,L1).

nth(1,[X|_],X) :- !.
nth(N,[_|L],X) :- N1 is N-1, nth(N1,L,X).

last([X],Y) :- !, X=Y.
last([_|L],X) :- last(L,X).

menu_select(L,X) :-
   write('Please select from list:'), nl,
   numitems(1,L), length(L,Max), repeat,
   repeat, read(Num), Num>0, Num=<Max, !, nth(Num,L,X).

   numitems(N,[X|L]) :- write('   '), write(N), write(': '), write(X), nl,
      N1 is N+1, numitems(N1,L).
   numitems(_,[]).

my_ttyget(X) :- seeing(F), see(user), get(X), see(F).
my_ttyget0(X) :- seeing(F), see(user), get0(X), see(F).

readtonl :- repeat, my_ttyget0(X), X=10, !.

readtonl(X) :- my_ttyget0(C),
   readt(C,N), name(X,N).

   readt(10,[]) :- !.
   readt(C,[C|L]) :- my_ttyget0(C1), readt(C1,L).

doall(Goal) :- Goal, fail.
doall(_).

allmatch(L,Pattern) :- member(X,L), \+ X=Pattern, !, fail.
allmatch(_,_).

% once(X) :- X, !.

% forall(X,Y) :- \+ ((X, \+Y)).

% Find n solutions of a goal

:- dynamic nsoln/2.

findn(N,Goal) :- gensym(ID), 
   assert(nsoln(ID,N)), Goal, 
   once(retract(nsoln(ID,Curr))), ((Curr=1, !); (Curr1 is Curr-1, assert(nsoln(ID,Curr1)))).

% ----------------------------------------------------------------------------
% random solution of a Prolog goal.
% Can be used, for instance, to generate a random OWL axiom:
% ?- rinterp(owl_axiom(X)).

rinterp(atom(X)) :- !, gensym(X).
rinterp((integer(X),X>=0)) :- !, pickrand([0,1,2,3],X).
rinterp(true) :- !.
rinterp((X,Y)) :- !, rinterp(X), rinterp(Y).
rinterp(Goal) :- 
   findall((Goal:-Body),(clause(Goal,Body),Body\==true),List1),
   findall((Goal:-true),clause(Goal,true),List2),
   pickrand(List2,List1,(X:-Y)), X=Goal, Y=Body, rinterp(Body).

pickrand([],L,X) :- !, pickrand(L,X).
pickrand(L,[],X) :- !, pickrand(L,X).
pickrand(L1,_,X) :- rand(0.8), !, pickrand(L1,X).
pickrand(_,L2,X) :- pickrand(L2,X).

:- dynamic num/1.

num(0).

gensym(X) :- retract(num(Y)), !, Y1 is Y+1, assert(num(Y1)),
   number_codes(Y1,C2), atom_codes(A2,C2), atom_concat('id',A2,X).
    
rand(X) :- R is random(100), R=<X*100, !.

pickrand(L,X) :- length(L,N), random(0,N,R), nthzero(R,L,X).

random(0,Int,R) :- R is random(Int).

nthzero(0,[X|_],X) :- !.
nthzero(N,[_|L],X) :- N1 is N-1, nthzero(N1,L,X).

% recording events

:- dynamic(rec/2).
:- dynamic(rec_eol/0).
:- dynamic(rec_end/0).

rec(_,_).
rec_eol.
rec_end.
